/* WPQ for WinderWitch color   by  */
/* 2003/07/10 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/bios.h>
#include <sys/libwwc.h>
#include <resource.h>

#include "bsvilwp.h" /*=====   wb_[t@CCN[h =====*/


#define CPN_TEXT 0   /*LpbgԍF*/
#define CPN_XOR 1   /*LpbgԍF*/
#define CHR_BYTE 32   /* PL̃f[^[oCg](16K) */


/*-------------------------------*/
res_t far *find_resource(WORD type, int index)
{
	res_t far *res = _pc->_resource;
	BYTE far *pByte;

	while(res->magic == RESID) {
		if(res->type == type && (index--) == 0)
			return res;

		pByte = (BYTE far *)res;
		pByte += (long)res->size << 4;
		res = (res_t far *)pByte;
	}
	return NULL;
}

/*-------------------------------*/
/*摜\[Xǂݍ*/
/*F@CfbNXԍ*/
/*߂lF=TRUE  /@s=FALSE  */

int read_resbm(int index)
{
#define COL_MAX   16
#define PAL_SIZE  32
#define HED_SIZE  16
	int iColNum;

	res_image_t	far *res;
	unsigned char far *pBuff;
	unsigned int far *pPal;

	res = (res_image_t	far *)find_resource(RESID_IMAGE,0);
	if(res==NULL)
		return FALSE;/*s*/

	if(res->header.type != RESID_IMAGE) {
	    text_screen_init();
	    text_put_string(1, 1, "RESID_IMAGE");
		key_wait();
		return FALSE;
	}

	if(res->format != IMAGE_16COLOR) {
	    text_screen_init();
	    text_put_string(1, 1, "IMAGE_16COLOR");
		key_wait();
		return FALSE;
	}

	pBuff = (unsigned char far *)res;

	/* pbg */
	pPal=(unsigned int far *)(pBuff + HED_SIZE);
    for(iColNum=0 ;iColNum<COL_MAX ;iColNum++) {
        wwc_palette_set_color(CPN_TEXT ,iColNum ,*(pPal+iColNum));
        wwc_palette_set_color(CPN_XOR  ,iColNum ,*(pPal+iColNum) ^ 0xffff);
    }

	/*tHgf[^*/
	wwc_font_set_colordata(0 ,(res->width * res->height) ,pBuff + HED_SIZE + PAL_SIZE);

	return TRUE;
}




/*------------------XN[ɃLN^*/
void subScreenClr(int iScr ,int iX ,int iY ,int iWmax ,int iHmax ,int iPal ,int iChn)
{
    int iW,iH;

    for(iH=0 ;iH<iHmax ;iH++) {
        for(iW=0 ;iW<iWmax ;iW++) {

            screen_fill_char(iScr ,iX+iW ,iY+iH, 1, 1 ,(iChn+iW+iH*(240/8)) | (iPal << CFSFT_PALETTE));
        }
    }
}
/*---------------^C\*/
void subTile(int iX ,int iY ,char *pStr)
{
    for(;;)
    {
        if( *pStr ==NULL)
            break;

        if( *pStr ==' ') {

            screen_fill_char(SCREEN1, iX, iY, 1, 1 , 0 | (CPN_TEXT << CFSFT_PALETTE));
        }else{
            screen_fill_char(SCREEN1, iX, iY, 1, 1 , 0 | (CPN_XOR << CFSFT_PALETTE));
        }
        iX++;
        pStr++;
    }
}


/*Βlij*/
int fncAbs(int d1)
{
    if(d1 < 0)
        return(-d1);
    else
        return(d1);
}


/*--------------------------C-------*/
void main(int argc, char *argv[])
{
	#define CHN_QUTE1	((  0/8)+(  0/8)*(240/8))
	#define CHN_QUTE2	(( 96/8)+(  0/8)*(240/8))
	#define CHN_GU		((192/8)+( 96/8)*(240/8))
	#define CHN_TYOKI	((192/8)+(  0/8)*(240/8))
	#define CHN_PA		((192/8)+( 48/8)*(240/8))
	#define CHN_TEXT	((  0/8)+(  0/8)*(240/8))

	int iKey;
	int iTimer;

    /* LCDKf[^ */
    /*iJ[ԍ000-011LCDKCJ[ԍ100-111LCDK j*/
    lcd_set_color(0x6530, 0xfca8);
    display_control( DCM_SCR1 );  /*XN[1\*/

    /* IL  */
    if (ilibIL->_open("@bmpsaver", (IL far *)&bsvIL) != E_FS_SUCCESS)    {
        /* error */
	    text_screen_init();
	    text_put_string(1, 1, "bmpsaver.il load error");
        key_wait();
    }else{
	    bs_sprite_set_range(0 ,0);
    	bs_set_target(KH_BS_SCREEN1 );
	}

	wwc_set_color_mode(COLOR_MODE_16COLOR);
	read_resbm(0);

    for(;;) {
		screen_fill_char(SCREEN1 ,0 ,0, 32, 32 ,0 | (0 << CFSFT_PALETTE));
		subScreenClr(SCREEN1 ,2,2 ,(96/8) ,(136/8) ,0 ,CHN_QUTE1);
		screen_set_scroll(SCREEN1, 0, 0);  /*XN[Wݒ*/
        iKey = key_wait();
        if (iKey & KEY_START)
			break;

		subTile(15 ,1 ,"  #  #  #  #");
		subTile(15 ,2 ,"  # # # ## #");
		subTile(15 ,3 ,"  # # # # ##");
		subTile(15 ,4 ,"  # ### #  #");
		subTile(15 ,5 ,"### # # #  #");
		for(iTimer=-8 ;iTimer <=8 ;iTimer++) {
			sys_wait(1);
			screen_set_scroll(SCREEN1, 0, 8-fncAbs(iTimer));     /*XN[Wݒ*/
		}
		sys_wait(5);

		subTile(15 ,7 ,"# # ### #  #");
		subTile(15 ,8 ,"##  #   ## #");
		subTile(15 ,9 ,"##  ### # ##");
		subTile(15 ,10,"# # #   #  #");
		subTile(15 ,11,"# # ### #  #");
		for(iTimer=-8 ;iTimer <=8 ;iTimer++) {
			sys_wait(1);
			screen_set_scroll(SCREEN1, 0, 8-fncAbs(iTimer));     /*XN[Wݒ*/
		}
		sys_wait(5);

		subTile(15 ,13 ,"### ### #  #");
		subTile(15 ,14 ,"# # # # ## #");
		subTile(15 ,15 ,"### # # # ##");
		subTile(15 ,16 ,"#   # # #  #");
		subTile(15 ,17 ,"#   ### #  #");
		for(iTimer=-8 ;iTimer <=8 ;iTimer++) {
			sys_wait(1);
			screen_set_scroll(SCREEN1, 0, 8-fncAbs(iTimer));     /*XN[Wݒ*/
		}

		sys_wait(5);

		subScreenClr(SCREEN1 ,2,2 ,(96/8) ,(136/8) ,0 ,CHN_QUTE2);
		switch(rand() % 3) {
        case 0:
			subScreenClr(SCREEN1 ,0,0 ,(48/8) ,(40/8) ,0 ,CHN_PA);
			break;
        case 1:
			subScreenClr(SCREEN1 ,0,0 ,(48/8) ,(48/8) ,0 ,CHN_GU);
			break;
        case 2:
			subScreenClr(SCREEN1 ,0,0 ,(48/8) ,(48/8) ,0 ,CHN_TYOKI);
			break;
		}

        iKey = key_wait();
        if (iKey & KEY_START)
			break;

		switch(iKey){
        case KEY_Y1:
			bsc_save_screen("sample.bmp",0,0,224,144);
			break;
        case KEY_Y2:
			bsc_save_screen_xmodem("sample.bmp", 0,0, 224, 144);
			break;
		}

    }
}

